Loading...
Searching...
No Matches
CFormulaPowerMultiplier Class Reference

`#include <ncSAFormula.h>`

## Public Member Functions

int | NVars () const
ring | GetBasering () const
| CFormulaPowerMultiplier (ring r)
virtual | ~CFormulaPowerMultiplier ()
Enum_ncSAType | GetPair (int i, int j) const
Enum_ncSAType & | GetPair (int i, int j)
poly | Multiply (int i, int j, const int n, const int m)

## Static Public Member Functions

static Enum_ncSAType | AnalyzePair (const ring r, int i, int j)
static poly | Multiply (Enum_ncSAType type, const int i, const int j, const int n, const int m, const ring r)
static poly | ncSA_1xy0x0y0 (const int i, const int j, const int n, const int m, const ring r)
static poly | ncSA_Mxy0x0y0 (const int i, const int j, const int n, const int m, const ring r)
static poly | ncSA_Qxy0x0y0 (const int i, const int j, const int n, const int m, const number m_q, const ring r)
static poly | ncSA_1xy0x0yG (const int i, const int j, const int n, const int m, const number m_g, const ring r)
static poly | ncSA_1xy0x0yT2 (const int i, const int j, const int n, const int m, const int k, const ring r)
static poly | ncSA_1xyAx0y0 (const int i, const int j, const int n, const int m, const number m_shiftCoef, const ring r)
static poly | ncSA_1xy0xBy0 (const int i, const int j, const int n, const int m, const number m_shiftCoef, const ring r)

## Private Member Functions

| CFormulaPowerMultiplier ()
| CFormulaPowerMultiplier (const CFormulaPowerMultiplier &)
CFormulaPowerMultiplier & | operator= (const CFormulaPowerMultiplier &)

## Private Attributes

Enum_ncSAType * | m_SAPairTypes
const int | m_NVars
const ring | m_BaseRing

## Detailed Description

Definition at line 27 of file ncSAFormula.h.

## Constructor & Destructor Documentation

## CFormulaPowerMultiplier() [1/3]

CFormulaPowerMultiplier::CFormulaPowerMultiplier | ( | ring | r | ) |

Definition at line 216 of file ncSAFormula.cc.

: m_NVars(r->N), m_BaseRing(r)
{
#if OUTPUT
PrintS("CFormulaPowerMultiplier::CFormulaPowerMultiplier(ring)!");
PrintLn();
#endif
m_SAPairTypes = (Enum_ncSAType*)omAlloc0( ((NVars() * (NVars()-1)) / 2) * sizeof(Enum_ncSAType) );
for( int i = 1; i < NVars(); i++ )
for( int j = i + 1; j <= NVars(); j++ )
GetPair(i, j) = AnalyzePairType(GetBasering(), i, j);
}
i
int i
Definition cfEzgcd.cc:132
CFormulaPowerMultiplier::NVars
int NVars() const
Definition ncSAFormula.h:38
CFormulaPowerMultiplier::m_BaseRing
const ring m_BaseRing
Definition ncSAFormula.h:33
CFormulaPowerMultiplier::m_NVars
const int m_NVars
Definition ncSAFormula.h:32
CFormulaPowerMultiplier::GetBasering
ring GetBasering() const
Definition ncSAFormula.h:39
CFormulaPowerMultiplier::m_SAPairTypes
Enum_ncSAType * m_SAPairTypes
Definition ncSAFormula.h:30
CFormulaPowerMultiplier::GetPair
Enum_ncSAType GetPair(int i, int j) const
Definition ncSAFormula.h:44
j
int j
Definition facHensel.cc:110
AnalyzePairType
static Enum_ncSAType AnalyzePairType(const ring r, int i, int j)
Definition ncSAFormula.cc:133
Enum_ncSAType
Enum_ncSAType
Definition ncSAFormula.h:16
omAlloc0
#define omAlloc0(size)
Definition omAllocDecl.h:211
PrintS
void PrintS(const char *s)
Definition reporter.cc:288
PrintLn
void PrintLn()
Definition reporter.cc:314

## ~CFormulaPowerMultiplier()

CFormulaPowerMultiplier::~CFormulaPowerMultiplier | ( |  | ) |

virtual

Definition at line 233 of file ncSAFormula.cc.

{
#if OUTPUT
PrintS("CFormulaPowerMultiplier::~CFormulaPowerMultiplier()!");
PrintLn();
#endif
omFreeSize((ADDRESS)m_SAPairTypes, ((NVars() * (NVars()-1)) / 2) * sizeof(Enum_ncSAType) );
}
ADDRESS
void * ADDRESS
Definition auxiliary.h:120
omFreeSize
#define omFreeSize(addr, size)
Definition omAllocDecl.h:260

## CFormulaPowerMultiplier() [2/3]

CFormulaPowerMultiplier::CFormulaPowerMultiplier | ( |  | ) |

private

## CFormulaPowerMultiplier() [3/3]

CFormulaPowerMultiplier::CFormulaPowerMultiplier | ( | const CFormulaPowerMultiplier & |  | ) |

private

## Member Function Documentation

## AnalyzePair()

Enum_ncSAType CFormulaPowerMultiplier::AnalyzePair | ( | const ring | r,
|  | int | i,
|  | int | j )

static

Definition at line 702 of file ncSAFormula.cc.

{
return ::AnalyzePairType( r, i, j);
}

## GetBasering()

ring CFormulaPowerMultiplier::GetBasering | ( |  | ) | const

inline

Definition at line 39 of file ncSAFormula.h.

{ return m_BaseRing; }

## GetPair() [1/2]

Enum_ncSAType & CFormulaPowerMultiplier::GetPair | ( | int | i,
|  | int | j )

inline

Definition at line 54 of file ncSAFormula.h.

{
assume( m_SAPairTypes != NULL );
assume( i > 0 );
assume( i < j );
assume( j <= NVars() );
return m_SAPairTypes[( (NVars() * ((i)-1) - ((i) * ((i)-1))/2 + (j)-1) - (i) )];
}
assume
#define assume(x)
Definition mod2.h:389
NULL
#define NULL
Definition omList.c:12

## GetPair() [2/2]

Enum_ncSAType CFormulaPowerMultiplier::GetPair | ( | int | i,
|  | int | j ) const

inline

Definition at line 44 of file ncSAFormula.h.

{
assume( m_SAPairTypes != NULL );
assume( i > 0 );
assume( i < j );
assume( j <= NVars() );
return m_SAPairTypes[( (NVars() * ((i)-1) - ((i) * ((i)-1))/2 + (j)-1) - (i) )];
}

## Multiply() [1/2]

poly CFormulaPowerMultiplier::Multiply | ( | Enum_ncSAType | type,
|  | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const ring | r )

static

Definition at line 696 of file ncSAFormula.cc.

{
return ncSA_Multiply( type, i, j, n, m, r);
}
m
int m
Definition cfEzgcd.cc:128
ncSA_Multiply
static poly ncSA_Multiply(Enum_ncSAType type, const int i, const int j, const int n, const int m, const ring r)
Definition ncSAFormula.cc:654

## Multiply() [2/2]

poly CFormulaPowerMultiplier::Multiply | ( | int | i,
|  | int | j,
|  | const int | n,
|  | const int | m )

Definition at line 707 of file ncSAFormula.cc.

{
return ncSA_Multiply( GetPair(i, j), i, j, n, m, GetBasering());
}

## ncSA_1xy0x0y0()

poly CFormulaPowerMultiplier::ncSA_1xy0x0y0 | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const ring | r )

static

Definition at line 715 of file ncSAFormula.cc.

{
return ::ncSA_1xy0x0y0(i, j, n, m, r);
}

## ncSA_1xy0x0yG()

poly CFormulaPowerMultiplier::ncSA_1xy0x0yG | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const number | m_g,
|  | const ring | r )

static

Definition at line 730 of file ncSAFormula.cc.

{
return ::ncSA_1xy0x0yG(i, j, n, m, m_g, r);
}

## ncSA_1xy0x0yT2()

poly CFormulaPowerMultiplier::ncSA_1xy0x0yT2 | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const int | k,
|  | const ring | r )

static

Definition at line 735 of file ncSAFormula.cc.

{
return ::ncSA_1xy0x0yT2(i, j, n, m, k, r);
}
k
int k
Definition cfEzgcd.cc:99

## ncSA_1xy0xBy0()

poly CFormulaPowerMultiplier::ncSA_1xy0xBy0 | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const number | m_shiftCoef,
|  | const ring | r )

static

Definition at line 745 of file ncSAFormula.cc.

{
return ::ncSA_1xy0xBy0(i, j, n, m, m_shiftCoef, r);
}

## ncSA_1xyAx0y0()

poly CFormulaPowerMultiplier::ncSA_1xyAx0y0 | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const number | m_shiftCoef,
|  | const ring | r )

static

Definition at line 740 of file ncSAFormula.cc.

{
return ::ncSA_1xyAx0y0(i, j, n, m, m_shiftCoef, r);
}

## ncSA_Mxy0x0y0()

poly CFormulaPowerMultiplier::ncSA_Mxy0x0y0 | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const ring | r )

static

Definition at line 720 of file ncSAFormula.cc.

{
return ::ncSA_Mxy0x0y0(i, j, n, m, r);
}

## ncSA_Qxy0x0y0()

poly CFormulaPowerMultiplier::ncSA_Qxy0x0y0 | ( | const int | i,
|  | const int | j,
|  | const int | n,
|  | const int | m,
|  | const number | m_q,
|  | const ring | r )

static

Definition at line 725 of file ncSAFormula.cc.

{
return ::ncSA_Qxy0x0y0(i, j, n, m, m_q, r);
}

## NVars()

int CFormulaPowerMultiplier::NVars | ( |  | ) | const

inline

Definition at line 38 of file ncSAFormula.h.

{ return m_NVars; }

## operator=()

CFormulaPowerMultiplier & CFormulaPowerMultiplier::operator= | ( | const CFormulaPowerMultiplier & |  | ) |

private

## Field Documentation

## m_BaseRing

const ring CFormulaPowerMultiplier::m_BaseRing

private

Definition at line 33 of file ncSAFormula.h.

## m_NVars

const int CFormulaPowerMultiplier::m_NVars

private

Definition at line 32 of file ncSAFormula.h.

## m_SAPairTypes

Enum_ncSAType* CFormulaPowerMultiplier::m_SAPairTypes

private

Definition at line 30 of file ncSAFormula.h.

The documentation for this class was generated from the following files:

- libpolys/polys/nc/ncSAFormula.h
- libpolys/polys/nc/ncSAFormula.cc